level-0 6.3 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199
  1. #!/bin/sh
  2. #
  3. # Run this script as root on the machine that has the tape drive, to make a
  4. # full (level-0) dump.
  5. #
  6. # If you give `now' as an argument, the dump is done immediately.
  7. # Otherwise, it waits until 1am, or until the hour given as argument.
  8. # Specify the hour as a number from 0 to 23.
  9. #
  10. # You must edit the file `backup-specs' to set the parameters for your site.
  11. # Useful for backup-specs, in case things have to be done slightly
  12. # differently for different dump levels.
  13. DUMP_LEVEL=0
  14. # Insure `mail' is in PATH.
  15. PATH="/usr/ucb:${PATH}"
  16. export PATH
  17. # This is not the most reliable test in the world. The following might be
  18. # more predictable:
  19. #
  20. # whoami="`whoami`"
  21. # euid="`sed -ne '/^'\"${whoami}\"':/{s/^[^:]*:[^:]*://;s/:.*//p;q;}' /etc/passwd`"
  22. # if [ "${euid}" != 0 ]; then ...
  23. #
  24. if [ ! -w / ]; then
  25. echo "The backup must be run as root or else some files will fail to be dumped."
  26. exit 1
  27. fi
  28. # Get the values of BACKUP_DIRS, BACKUP_FILES, and other variables.
  29. . ./backup-specs
  30. # Maybe sleep until around specified or default hour.
  31. if [ "${1}" != "now" ]; then
  32. if [ "${1}x" != "x" ]; then
  33. spec="${1}"
  34. else
  35. spec="${BACKUP_HOUR}"
  36. fi
  37. pausetime="`date | awk '
  38. {
  39. hr = substr($4, 1, 2);
  40. mn = substr($4, 4, 2);
  41. if((hr + 0) < (spec + 0))
  42. print 3600 * (spec - hr) - 60 * mn;
  43. else
  44. print 3600 * (spec + (24 - hr)) - 60 * mn;
  45. }' spec=\"${spec}\"`"
  46. clear
  47. echo "${SLEEP_MESSAGE}"
  48. sleep "${pausetime}"
  49. fi
  50. # start doing things
  51. # Put startdate in the subject line of mailed report, since if it happens
  52. # to run longer than 24 hours (as may be the case if someone forgets to put
  53. # in the next volume of the tape in adequate time), the backup date won't
  54. # appear too misleading.
  55. startdate="`date`"
  56. here="`pwd`"
  57. # Logfile name should be in the form ``log-1993-03-18-level-0''
  58. # i.e. year-month-date. This format is useful for sorting by name, since
  59. # logfiles are intentionally kept online for future reference.
  60. LOGFILE="log-`date | sed -ne '
  61. s/[^ ]* *\([^ ]*\) *\([^ ]*\).* \([^ ]*\)$/\3-\1-\2/
  62. /-[0-9]$/s/\([0-9]\)$/0\1/
  63. /Jan/{s/Jan/01/p;q;}
  64. /Feb/{s/Feb/02/p;q;}
  65. /Mar/{s/Mar/03/p;q;}
  66. /Apr/{s/Apr/04/p;q;}
  67. /May/{s/May/05/p;q;}
  68. /Jun/{s/Jun/06/p;q;}
  69. /Jul/{s/Jul/07/p;q;}
  70. /Aug/{s/Aug/08/p;q;}
  71. /Sep/{s/Sep/09/p;q;}
  72. /Oct/{s/Oct/10/p;q;}
  73. /Nov/{s/Nov/11/p;q;}
  74. /Dec/{s/Dec/12/p;q;}'`-level-${DUMP_LEVEL}"
  75. localhost="`hostname | sed -e 's/\..*//'`"
  76. TAR_PART1="${TAR} -c --multi-volume --one-file-system --block=${BLOCKING} --sparse --volno-file=${VOLNO_FILE}"
  77. # Only use --info-script if DUMP_REMIND_SCRIPT was defined in backup-specs
  78. if [ "x${DUMP_REMIND_SCRIPT}" != "x" ]; then
  79. TAR_PART1="${TAR_PART1} --info-script='${DUMP_REMIND_SCRIPT}'"
  80. fi
  81. # Make sure the log file did not already exist. Create it.
  82. if [ -f "${LOGFILE}" ] ; then
  83. echo "Log file ${LOGFILE} already exists." 1>&2
  84. exit 1
  85. else
  86. touch "${LOGFILE}"
  87. fi
  88. # Most everything below here is run in a subshell for which all output is
  89. # piped through `tee' to the logfile. Doing this, instead of having
  90. # multiple pipelines all over the place, is cleaner and allows access to
  91. # the exit value from various commands more easily.
  92. (
  93. # Caveat: Some version of `mt' require `-t', not `-f'.
  94. mt -f "${TAPE_FILE}" rewind
  95. rm -f "${VOLNO_FILE}"
  96. set - ${BACKUP_DIRS}
  97. while [ $# -ne 0 ] ; do
  98. date="`date`"
  99. remotehost="`echo \"${1}\" | sed -e 's/:.*$//'`"
  100. fs="`echo \"${1}\" | sed -e 's/^.*://'`"
  101. fsname="`echo \"${1}\" | sed -e 's/\//:/g'`"
  102. # This filename must be absolute; it is opened on the machine that runs tar.
  103. TAR_PART2="--listed=/etc/tar-backup/temp.level-0"
  104. TAR_PART3="--label='Full backup of ${fs} on ${remotehost} at ${date}' -C ${fs} ."
  105. echo "Backing up ${1} at ${date}"
  106. # Actually back things up.
  107. if [ "z${localhost}" != "z${remotehost}" ] ; then
  108. rsh "${remotehost}" mkdir /etc/tar-backup > /dev/null 2>&1
  109. rsh "${remotehost}" rm -f /etc/tar-backup/temp.level-0
  110. rsh "${remotehost}" ${TAR_PART1} -f "${localhost}:${TAPE_FILE}" ${TAR_PART2} ${TAR_PART3}
  111. else
  112. mkdir /etc/tar-backup > /dev/null 2>&1
  113. rm -f /etc/tar-backup/temp.level-0
  114. # Using `sh -c exec' causes nested quoting and shell substitution
  115. # to be handled here in the same way rsh handles it.
  116. sh -c "exec ${TAR_PART1} -f \"${TAPE_FILE}\" ${TAR_PART2} ${TAR_PART3}"
  117. fi
  118. # `rsh' doesn't exit with the exit status of the remote command. What
  119. # stupid lossage. TODO: think of a reliable workaround.
  120. if [ $? -ne 0 ] ; then
  121. echo "Backup of ${1} failed." 1>&2
  122. # I'm assuming that the tar will have written an empty
  123. # file to the tape, otherwise I should do a cat here.
  124. else
  125. if [ "z${localhost}" != "z${remotehost}" ] ; then
  126. rsh "${remotehost}" mv -f /etc/tar-backup/temp.level-0 "/etc/tar-backup/${fsname}.level-0"
  127. else
  128. mv -f /etc/tar-backup/temp.level-0 "/etc/tar-backup/${fsname}.level-0"
  129. fi
  130. fi
  131. ${TAPE_STATUS}
  132. sleep 60
  133. shift
  134. done
  135. # Dump any individual files requested.
  136. if [ "x${BACKUP_FILES}" != "x" ] ; then
  137. date="`date`"
  138. TAR_PART2="--listed=/etc/tar-backup/temp.level-0"
  139. TAR_PART3="--label='Full backup of miscellaneous files at ${date}'"
  140. mkdir /etc/tar-backup > /dev/null 2>&1
  141. rm -f /etc/tar-backup/temp.level-0
  142. echo "Backing up miscellaneous files at ${date}"
  143. # Using `sh -c exec' causes nested quoting and shell substitution
  144. # to be handled here in the same way rsh handles it.
  145. sh -c "exec ${TAR_PART1} -f \"${TAPE_FILE}\" ${TAR_PART2} ${TAR_PART3} ${BACKUP_FILES}"
  146. # `rsh' doesn't exit with the exit status of the remote command. What
  147. # lossage. TODO: think of a reliable workaround.
  148. if [ $? -ne 0 ] ; then
  149. echo "Backup of miscellaneous files failed."
  150. # I'm assuming that the tar will have written an empty
  151. # file to the tape, otherwise I should do a cat here.
  152. else
  153. mv -f /etc/tar-backup/temp.level-0 /etc/tar-backup/misc.level-0
  154. fi
  155. ${TAPE_STATUS}
  156. else
  157. echo "No miscellaneous files specified"
  158. fi
  159. # Caveat: some versions of `mt' use `-t' instead of `-f'.
  160. mt -f "${TAPE_FILE}" rewind
  161. mt -f "${TAPE_FILE}" offl
  162. ) 2>&1 | tee -a "${LOGFILE}"
  163. echo "Sending the dump log to ${ADMINISTRATOR}"
  164. mail -s "Results of backup started ${startdate}" ${ADMINISTRATOR} < "${LOGFILE}"
  165. # eof